From 58014345d15f60b746a6ce62cc5dc8b83762da3b Mon Sep 17 00:00:00 2001
From: yylyyl <yangyiliang@gmail.com>
Date: Sat, 19 Sep 2015 20:11:09 +0800
Subject: [PATCH 10/15] Applied chan-dongle-alphanumeric-pdu.patch.

USSD for E261 works now.

Source: https://code.google.com/p/asterisk-chan-dongle/issues/detail?id=17
---
 README.txt    |  1 +
 at_response.c |  1 +
 pdu.c         | 15 ++++++++++++++-
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/at_response.c b/at_response.c
index 83e800a..3ac5411 100644
--- a/at_response.c
+++ b/at_response.c
@@ -1616,6 +1616,7 @@ static int at_response_cgmm (struct pvt* pvt, const char* str)
 		"E153",
 		"E156B",
 		"E1752",
+		"E261"
 	};
 
 	ast_copy_string (pvt->model, str, sizeof (pvt->model));
diff --git a/pdu.c b/pdu.c
index be840e0..d2c8403 100644
--- a/pdu.c
+++ b/pdu.c
@@ -182,6 +182,8 @@
 */
 
 #define NUMBER_TYPE_INTERNATIONAL		0x91
+#define NUMBER_TYPE_NATIONAL			0xC8
+#define NUMBER_TYPE_ALPHANUMERIC		0xD0
 
 /* Message Type Indicator Parameter */
 #define PDUTYPE_MTI_SHIFT			0
@@ -229,6 +231,7 @@
 
 #define PDU_PID_SMS				0x00		/* bit5 No interworking, but SME-to-SME protocol = SMS */
 #define PDU_PID_EMAIL				0x32		/* bit5 Telematic interworking, bits 4..0 0x 12  = email */
+#define PDU_PID_SMS_REPLACE_MASK		0x40		/* bit7 Replace Short Message function activated (TP-PID = 0x41 to 0x47) */
 
 /* DCS */
 /*   bits 1..0 Class */
@@ -454,7 +457,15 @@ static int pdu_parse_number(char ** pdu, size_t * pdu_length, unsigned digits, i
 		{
 			char digit;
 			if(*toa == NUMBER_TYPE_INTERNATIONAL)
+			{
 				*number++ = '+';
+			}
+			else if(*toa == NUMBER_TYPE_ALPHANUMERIC)
+			{
+				for(; syms > 0; syms--, *pdu += 1, *pdu_length -= 1)
+					*number++ = pdu[0][0];
+				return *pdu - begin;
+			}
 			for(; syms > 0; syms -= 2, *pdu += 2, *pdu_length -= 2)
 			{
 				digit = pdu_code2digit(pdu[0][1]);
@@ -690,10 +701,12 @@ EXPORT_DEF const char * pdu_parse(char ** pdu, size_t tpdu_length, char * oa, si
 						{
 							int pid = pdu_parse_byte(pdu, &pdu_length);
 							*oa_enc = STR_ENCODING_7BIT;
+							if(oa_toa == NUMBER_TYPE_ALPHANUMERIC)
+								*oa_enc = STR_ENCODING_7BIT_HEX;
 							if(pid >= 0)
 							{
 								/* TODO: support other types of messages */
-								if(pid == PDU_PID_SMS)
+								if( (pid == PDU_PID_SMS) || (pid & PDU_PID_SMS_REPLACE_MASK) )
 								{
 									int dcs = pdu_parse_byte(pdu, &pdu_length);
 									if(dcs >= 0)

